# TODO:
# - update _htmldir (/usr/share for static data, /var/lib for generated)
# - accept multiple config definition in /etc/sysconfig/mrtg by cron-started
#   mrtg. Thats why sysconfig file is in main package.
# - start mrtg cronjob as non-root user (configurable in sysconfig file, because
#   root is required for some sort of stats)

%include	/usr/lib/rpm/macros.perl
Summary:	Multi Router Traffic Grapher
Summary(es.UTF-8):	Herramienta para hacer gráficos de empleo en la red
Summary(pl.UTF-8):	MRTG - generator obrazów obciążenia łącz
Summary(pt_BR.UTF-8):	Ferramenta para fazer gráficos do uso da rede
Summary(ru.UTF-8):	MRTG - программа изображения граффиков, изображающих траффик на множестве роутеров
Name:		mrtg
Version:	2.17.7
Release:	1
License:	GPL
Group:		Applications/Networking
Source0:	http://oss.oetiker.ch/mrtg/pub/%{name}-%{version}.tar.gz
# Source0-md5:	eada3870c0419e425299401486600d95
Source1:	%{name}.cfg
Source2:	%{name}.init
Source3:	%{name}.sysconfig
Source4:	%{name}.logrotate
Source5:	%{name}.cron
Source6:	%{name}-indexmaker.cron
Source7:	%{name}.tmpfiles
Patch0:		%{name}.path.patch
Patch1:		%{name}-Socket6_conflicts.patch
URL:		http://oss.oetiker.ch/mrtg/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	gd-devel >= 2.0.1
BuildRequires:	libpng-devel >= 1.0.8
BuildRequires:	perl-SNMP_Session >= 1.05
BuildRequires:	perl-devel >= 1:5.8.0
BuildRequires:	rpm-perlprov >= 4.1-13
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	perl(SNMP_util) >= 1.04
Conflicts:	logrotate < 3.8.0
Suggests:	rrdtool
Suggests:	perl-rrdtool
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_htmldir	/home/services/httpd/html/mrtg

%description
The Multi Router Traffic Grapher (MRTG) is a tool to monitor the
traffic load on network-links. MRTG generates HTML pages containing
PNG images which provide a LIVE visual representation of this traffic.

%description -l es.UTF-8
Herramienta para hacer gráficos de empleo en la red.

%description -l pl.UTF-8
Multi Router Traffic Grapher (MRTG) to narzędzie służące do
monitorowania obciążenia łącz sieciowych. MRTG generuje strony HTML
zawierające obrazki PNG przedstawiające aktualne obciążenie łącz.

%description -l pt_BR.UTF-8
O MRTG é uma ferramenta parar monitorar o tráfego de links de rede.
Ele gera páginas HTML contendo imagens GIF que provêm uma sensação
realística deste gráfico.

%package cron
Summary:	Files that allow running mrtg via crond
Summary(pl.UTF-8):	Pliki pozwalające uruchamiać mrtg z crona
Group:		Applications/Networking
Requires:	%{name} = %{version}-%{release}
Requires:	crondaemon
Provides:	mrtg-start
Obsoletes:	mrtg-init
Obsoletes:	mrtg-start

%description cron
Files that allow running mrtg via crond.

%description cron -l pl.UTF-8
Pliki pozwalające uruchamiać mrtg z crona.

%package init
Summary:	Files that allow running mrtg via rc-scripts
Summary(pl.UTF-8):	Pliki pozwalające uruchamiać mrtg z poziomu rc-scripts
Group:		Daemons
Requires(post,preun):	/sbin/chkconfig
Requires:	%{name} = %{version}-%{release}
Requires:	crondaemon
Requires:	rc-scripts >= 0.4.3.7
Provides:	mrtg-start
Obsoletes:	mrtg-cron
Obsoletes:	mrtg-start

%description init
Files that allow running mrtg via rc-scripts.

%description init -l pl.UTF-8
Pliki pozwalające uruchamiać mrtg z poziomu rc-scripts.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
rm -rf lib/mrtg2/Pod

%build
%{__aclocal}
%{__autoconf}
%configure
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{cron.d,rc.d/init.d,sysconfig,logrotate.d},%{_sysconfdir}/mrtg/conf.d,%{_htmldir}} \
	$RPM_BUILD_ROOT{%{_bindir},%{_libdir}/%{name},%{perl_vendorlib},%{_mandir}/man1} \
	$RPM_BUILD_ROOT{/var/log/{mrtg,archive/mrtg},/var/{lib,run}/mrtg} \
	$RPM_BUILD_ROOT/usr/lib/tmpfiles.d

cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/mrtg
install -p %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/mrtg
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/mrtg
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/logrotate.d/mrtg
install -p %{SOURCE5} $RPM_BUILD_ROOT%{_bindir}/mrtg-cronjob
install -p %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/indexmaker-cronjob
ln -sf %{_sysconfdir}/mrtg/mrtg.cfg $RPM_BUILD_ROOT%{_htmldir}/mrtg.cfg
cp -a images/* $RPM_BUILD_ROOT%{_htmldir}
install %{SOURCE7} $RPM_BUILD_ROOT/usr/lib/tmpfiles.d/%{name}.conf

install -p bin/{cfgmaker,indexmaker} $RPM_BUILD_ROOT%{_libdir}/mrtg
install -p bin/{rateup,mrtg} $RPM_BUILD_ROOT%{_bindir}
cp -a lib/mrtg2/locales_mrtg.pm $RPM_BUILD_ROOT%{perl_vendorlib}
cp -a lib/mrtg2/MRTG_lib.pm $RPM_BUILD_ROOT%{perl_vendorlib}
cp -a doc/*.1	$RPM_BUILD_ROOT%{_mandir}/man1

ln -sf ../mrtg.cfg $RPM_BUILD_ROOT%{_sysconfdir}/mrtg/conf.d

tar -cf contrib.tar contrib

cat  << EOF > $RPM_BUILD_ROOT/etc/cron.d/mrtg
*/5 * * * * stats umask 022; /bin/nice -n 19 %{_bindir}/mrtg-cronjob
*/5 * * * * stats umask 022; /bin/nice -n 19 %{_bindir}/indexmaker-cronjob 2> /dev/null
EOF

sed -i 's#/''usr/lib#%{_libdir}#' $RPM_BUILD_ROOT%{_bindir}/indexmaker-cronjob

%clean
rm -rf $RPM_BUILD_ROOT

%post init
/sbin/chkconfig --add mrtg
%service mrtg restart

%preun init
if [ "$1" = "0" ]; then
	%service mrtg stop
	/sbin/chkconfig --del mrtg
fi

%files
%defattr(644,root,root,755)
%doc contrib.tar doc/*.txt
%attr(751,root,stats) %dir %{_sysconfdir}/mrtg
%attr(751,root,stats) %dir %{_sysconfdir}/mrtg/conf.d
%attr(640,root,stats) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/mrtg/mrtg.cfg
%attr(640,root,stats) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/mrtg/conf.d/mrtg.cfg
%attr(640,root,stats) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/mrtg
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/mrtg
%attr(755,stats,logs) %dir %{_htmldir}
%{_htmldir}/*
%{perl_vendorlib}/*.pm
%attr(755,root,root) %{_bindir}/mrtg
%attr(755,root,root) %{_bindir}/rateup
%dir %{_libdir}/mrtg
%attr(755,root,root) %{_libdir}/mrtg/cfgmaker
%attr(755,root,root) %{_libdir}/mrtg/indexmaker
%attr(1751,stats,logs) %dir /var/log/mrtg
%attr(751,stats,logs) %dir /var/log/archive/mrtg
%attr(755,stats,stats) %dir /var/run/mrtg
%attr(755,stats,stats) %dir /var/lib/mrtg
/usr/lib/tmpfiles.d/%{name}.conf
%{_mandir}/man1/*

%files cron
%defattr(644,root,root,755)
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/mrtg
%attr(755,root,root) %{_bindir}/indexmaker-cronjob
%attr(755,root,root) %{_bindir}/mrtg-cronjob

%files init
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/mrtg
%changelog
* Mon Feb 18 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mrtg.git;a=log;h=master

* Mon Feb 18 2019 Adam Gołębiowski <adamg@pld-linux.org> 29e098e
- updated to 2.17.7

* Mon Feb 18 2019 Adam Gołębiowski <adamg@pld-linux.org> c027983
- update dto 2.17.7

* Wed May 06 2015 Jan Rękorajski <baggins@pld-linux.org> 0d3fef2
- x32 rebuild
- release 8 (by relup.sh)

* Thu Sep 19 2013 Jacek Konieczny <jajcus@jajcus.net> 2c9927a
- fix Socket6 import conflict messages

* Thu Jul 04 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 5fbf5bf
- release 6 (by relup.sh)

* Sun Feb 05 2012 Jan Rękorajski <baggins@pld-linux.org> b7211f5
- rel 5
- give logrotate a chance to access log/archive dir

* Sun Feb 05 2012 Jan Rękorajski <baggins@pld-linux.org> 4e07041
- rel 4
- logrotate 3.8.0 requires "su" option for non-root writable dirs

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> 22552dd
- release 3

* Tue Jan 31 2012 Jan Rękorajski <baggins@pld-linux.org> e9f708d
- added tmpfiles config for systemd

* Mon Jan 30 2012 Jan Rękorajski <baggins@pld-linux.org> 68ed15c
- add systemd tmpfiles config

* Fri Nov 18 2011 Paweł Gołaszewski <blues@pld-linux.org> b46d834
- rel.2 - force starting without LANG set. mrtg doesn't work with utf
  locale (in fact: doesn't need locale at all)

* Tue Sep 27 2011 Paweł Gołaszewski <blues@pld-linux.org> a25bebf
- suggest rrdtool and perl modules for configuration with rrd logs collects

* Mon Sep 19 2011 Paweł Gołaszewski <blues@pld-linux.org> f0eec5d
- ...eeee... I don't remember :)

* Sun Dec 19 2010 Adam Gołębiowski <adamg@pld-linux.org> a06e850
- updated to 2.17.0

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> 42ad4c4
- release 4

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> a0d57ec
- drop -use-perl-pod.patch, makefile not used to install, files installed manually in spec

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> 13bed06
- more common approach for config testing (like i've used elsewhere)

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> 4fc9483
- reworked config handling to support old and new mode more transparently

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> 720c615
- unify, fixes old config i vs f file var mismatch

* Sun Dec 12 2010 Elan Ruusamäe <glen@pld-linux.org> f1f6011
- check configs with same user mrtg will be ran afterwards to catch permission errors

